/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.61 Revision 1.99
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.99 2010/07/06 18:55:50 vapier Exp $
4# 4
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# @ECLASS: autotools.eclass
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# @MAINTAINER:
7# 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION:
8# This eclass is for handling autotooled software packages that 10# This eclass is for safely handling autotooled software packages that need to
9# needs to regenerate their build scripts. 11# regenerate their build scripts. All functions will abort in case of errors.
10# 12#
11# NB: If you add anything, please comment it! 13# NB: If you add anything, please comment it!
12 14
13inherit eutils libtool 15inherit eutils libtool
16
17# @ECLASS-VARIABLE: WANT_AUTOCONF
18# @DESCRIPTION:
19# The major version of autoconf your package needs
20: ${WANT_AUTOCONF:=latest}
21
22# @ECLASS-VARIABLE: WANT_AUTOMAKE
23# @DESCRIPTION:
24# The major version of automake your package needs
25: ${WANT_AUTOMAKE:=latest}
26
27# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
28# @DESCRIPTION:
29# CONSTANT!
30# The latest major version/slot of automake available on each arch.
31# If a newer version is stable on any arch, and is NOT reflected in this list,
32# then circular dependencies may arise during emerge @system bootstraps.
33# Do NOT change this variable in your ebuilds!
34_LATEST_AUTOMAKE='1.11'
14 35
15_automake_atom="sys-devel/automake" 36_automake_atom="sys-devel/automake"
16_autoconf_atom="sys-devel/autoconf" 37_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]]; then 38if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in 39 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch 40 none) _automake_atom="" ;; # some packages don't require automake at all
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;; 41 # if you change the "latest" version here, change also autotools_run_tool
42 # this MUST reflect the latest stable major version for each arch!
43 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;;
21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 44 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac 45 esac
46 export WANT_AUTOMAKE
23fi 47fi
24 48
25if [[ -n ${WANT_AUTOCONF} ]] ; then 49if [[ -n ${WANT_AUTOCONF} ]] ; then
26 case ${WANT_AUTOCONF} in 50 case ${WANT_AUTOCONF} in
51 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 52 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
53 # if you change the “latest” version here, change also autotools_run_tool
28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 54 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;;
55 *) _autoconf_atom="INCORRECT-WANT_AUTOCONF-SETTING-IN-EBUILD" ;;
29 esac 56 esac
57 export WANT_AUTOCONF
30fi 58fi
31DEPEND="${_automake_atom} 59
32 ${_autoconf_atom} 60AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom}"
33 sys-devel/libtool" 61[[ ${CATEGORY}/${PN} != "sys-devel/libtool" ]] && AUTOTOOLS_DEPEND="${AUTOTOOLS_DEPEND} >=sys-devel/libtool-2.2.6b"
34RDEPEND="" 62RDEPEND=""
63
64# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
65# @DESCRIPTION:
66# Set to 'no' to disable automatically adding to DEPEND. This lets
67# ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
68# their own DEPEND string.
69: ${AUTOTOOLS_AUTO_DEPEND:=yes}
70if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
71 DEPEND=${AUTOTOOLS_DEPEND}
72fi
73
35unset _automake_atom _autoconf_atom 74unset _automake_atom _autoconf_atom
36 75
37# Variables: 76# @ECLASS-VARIABLE: AM_OPTS
38# 77# @DESCRIPTION:
39# AT_M4DIR - Additional director(y|ies) aclocal should search
40# AM_OPTS - Additional options to pass to automake during 78# Additional options to pass to automake during
41# eautoreconf call. 79# eautoreconf call.
80
81# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
82# @DESCRIPTION:
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes', 83# Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with 84# useful when elibtoolize needs to be ran with
44# particular options 85# particular options
45 86
46# Functions:
47#
48# eautoreconf() - Should do a full autoreconf - normally what most people
49# will be interested in. Also should handle additional
50# directories specified by AC_CONFIG_SUBDIRS.
51# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
52# to search for macro's.
53# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
54# with elibtoolize() from libtool.eclass
55# eautoconf - Runs autoconf.
56# eautoheader - Runs autoheader.
57# eautomake - Runs automake
58#
59
60# XXX: M4DIR should be depreciated 87# XXX: M4DIR should be deprecated
88# @ECLASS-VARIABLE: AT_M4DIR
89# @DESCRIPTION:
90# Additional director(y|ies) aclocal should search
61AT_M4DIR=${AT_M4DIR:-${M4DIR}} 91: ${AT_M4DIR:=${M4DIR}}
62AT_GNUCONF_UPDATE="no" 92AT_GNUCONF_UPDATE="no"
63 93
64 94
95# @FUNCTION: eautoreconf
96# @DESCRIPTION:
65# This function mimes the behavior of autoreconf, but uses the different 97# This function mimes the behavior of autoreconf, but uses the different
66# eauto* functions to run the tools. It doesn't accept parameters, but 98# eauto* functions to run the tools. It doesn't accept parameters, but
67# the directory with include files can be specified with AT_M4DIR variable. 99# the directory with include files can be specified with AT_M4DIR variable.
100#
101# Should do a full autoreconf - normally what most people will be interested in.
102# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
68eautoreconf() { 103eautoreconf() {
69 local pwd=$(pwd) x auxdir 104 local x auxdir g
70 105
71 if [[ -z ${AT_NO_RECURSIVE} ]]; then 106 if [[ -z ${AT_NO_RECURSIVE} ]]; then
72 # Take care of subdirs 107 # Take care of subdirs
73 for x in $(autotools_get_subdirs); do 108 for x in $(autotools_get_subdirs); do
74 if [[ -d ${x} ]] ; then 109 if [[ -d ${x} ]] ; then
75 cd "${x}" 110 pushd "${x}" >/dev/null
76 AT_NOELIBTOOLIZE="yes" eautoreconf 111 AT_NOELIBTOOLIZE="yes" eautoreconf
77 cd "${pwd}" 112 popd >/dev/null
78 fi 113 fi
79 done 114 done
80 fi 115 fi
81 116
82 auxdir=$(autotools_get_auxdir) 117 auxdir=$(autotools_get_auxdir)
83 118
84 einfo "Running eautoreconf in '$(pwd)' ..." 119 einfo "Running eautoreconf in '${PWD}' ..."
85 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 120 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
86 eaclocal 121 eaclocal
122 [[ ${CHOST} == *-darwin* ]] && g=g
123 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
124 _elibtoolize --copy --force --install
125 else
87 _elibtoolize --copy --force 126 _elibtoolize --copy --force
127 fi
88 eautoconf 128 eautoconf
89 eautoheader 129 eautoheader
90 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 130 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
91 131
92 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 132 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
93 133
94 # Call it here to prevent failures due to elibtoolize called _before_ 134 # Call it here to prevent failures due to elibtoolize called _before_
95 # eautoreconf. 135 # eautoreconf. We set $S because elibtoolize runs on that #265319
96 elibtoolize 136 S=${PWD} elibtoolize
97 137
98 return 0 138 return 0
99} 139}
100 140
141# @FUNCTION: eaclocal
142# @DESCRIPTION:
101# These functions runs the autotools using autotools_run_tool with the 143# These functions runs the autotools using autotools_run_tool with the
102# specified parametes. The name of the tool run is the same of the function 144# specified parametes. The name of the tool run is the same of the function
103# without e prefix. 145# without e prefix.
104# They also force installing the support files for safety. 146# They also force installing the support files for safety.
147# Respects AT_M4DIR for additional directories to search for macro's.
105eaclocal() { 148eaclocal() {
106 local aclocal_opts 149 local aclocal_opts
150
151 local amflags_file
152 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
153 [[ -e ${amflags_file} ]] || continue
154 aclocal_opts=$(sed -n '/^ACLOCAL_AMFLAGS[[:space:]]*=/s:[^=]*=::p' ${amflags_file})
155 eval aclocal_opts=\"${aclocal_opts}\"
156 break
157 done
107 158
108 if [[ -n ${AT_M4DIR} ]] ; then 159 if [[ -n ${AT_M4DIR} ]] ; then
109 for x in ${AT_M4DIR} ; do 160 for x in ${AT_M4DIR} ; do
110 case "${x}" in 161 case "${x}" in
111 "-I") 162 "-I")
117 ;; 168 ;;
118 esac 169 esac
119 done 170 done
120 fi 171 fi
121 172
122 autotools_set_versions
123 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 173 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
124 autotools_run_tool aclocal "$@" ${aclocal_opts} 174 autotools_run_tool aclocal "$@" ${aclocal_opts}
125} 175}
126 176
177# @FUNCTION: _elibtoolize
178# @DESCRIPTION:
179# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
180# libtool.eclass.
127_elibtoolize() { 181_elibtoolize() {
128 local opts 182 local opts g=
129 local lttest
130 183
131 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro, 184 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
132 # check for both it and the current AC_PROG_LIBTOOL) 185 # check for both it and the current AC_PROG_LIBTOOL)
133 lttest="$(autotools_check_macro "AC_PROG_LIBTOOL")$(autotools_check_macro "AM_PROG_LIBTOOL")" 186 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
134 [[ -n $lttest ]] || return 0
135 187
136 [[ -f Makefile.am ]] && opts="--automake" 188 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
137 189
138 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize" 190 [[ ${CHOST} == *-darwin* ]] && g=g
139 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts} 191 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
140 192
141 # Need to rerun aclocal 193 # Need to rerun aclocal
142 eaclocal 194 eaclocal
143} 195}
144 196
197# @FUNCTION: eautoheader
198# @DESCRIPTION:
199# Runs autoheader.
145eautoheader() { 200eautoheader() {
146 # Check if we should run autoheader 201 # Check if we should run autoheader
147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 202 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
148 autotools_set_versions
149 NO_FAIL=1 autotools_run_tool autoheader "$@" 203 NO_FAIL=1 autotools_run_tool autoheader "$@"
150} 204}
151 205
206# @FUNCTION: eautoconf
207# @DESCRIPTION:
208# Runs autoconf.
152eautoconf() { 209eautoconf() {
153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 210 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
154 echo 211 echo
155 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 212 eerror "No configure.{ac,in} present in '${PWD}'!"
156 echo 213 echo
157 die "No configure.{ac,in} present!" 214 die "No configure.{ac,in} present!"
158 fi 215 fi
159 216
160 autotools_set_versions
161 autotools_run_tool autoconf "$@" 217 autotools_run_tool autoconf "$@"
162} 218}
163 219
220# @FUNCTION: eautomake
221# @DESCRIPTION:
222# Runs automake.
164eautomake() { 223eautomake() {
165 local extra_opts 224 local extra_opts
225 local makefile_name
166 226
227 # Run automake if:
228 # - a Makefile.am type file exists
229 # - a Makefile.in type file exists and the configure
230 # script is using the AM_INIT_AUTOMAKE directive
231 for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do
232 [[ -f ${makefile_name} ]] && break
233 done
167 [[ -f Makefile.am ]] || return 0 234 [[ -z ${makefile_name} ]] && return 0
168 235
169 autotools_set_versions 236 if [[ ${makefile_name} == *.in ]] ; then
237 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then
238 return 0
239 fi
240
170 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 241 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
171 local used_automake 242 local used_automake
172 local installed_automake 243 local installed_automake
173 244
174 installed_automake=$(automake --version | head -n 1 | \ 245 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
175 sed -e 's:.*(GNU automake) ::') 246 sed -e 's:.*(GNU automake) ::')
176 used_automake=$(head -n 1 < Makefile.in | \ 247 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
177 sed -e 's:.*by automake \(.*\) from .*:\1:') 248 sed -e 's:.*by automake \(.*\) from .*:\1:')
178 249
179 if [[ ${installed_automake} != ${used_automake} ]]; then 250 if [[ ${installed_automake} != ${used_automake} ]]; then
180 einfo "Automake used for the package (${used_automake}) differs from" 251 einfo "Automake used for the package (${used_automake}) differs from"
181 einfo "the installed version (${installed_automake})." 252 einfo "the installed version (${installed_automake})."
189 260
190 # --force-missing seems not to be recognized by some flavours of automake 261 # --force-missing seems not to be recognized by some flavours of automake
191 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 262 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
192} 263}
193 264
194autotools_set_versions() { 265# @FUNCTION: eautopoint
195 [[ -n ${autotools_version_sets} ]] && return 0 266# @DESCRIPTION:
196 267# Runs autopoint (from the gettext package).
197 if [[ -n ${WANT_AUTOCONF} ]]; then 268eautopoint() {
198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5" 269 autotools_run_tool autopoint "$@"
199 export WANT_AUTOCONF
200 einfo "Requested autoconf ${WANT_AUTOCONF}"
201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)"
202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)"
203 else
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/"
205 fi
206
207 if [[ -n ${WANT_AUTOMAKE} ]]; then
208 local latest_automake
209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
210 latest_automake="latest: "
211 for amver in 1.10 1.9 1.8 1.7 1.6; do
212 WANT_AUTOMAKE="${amver}"
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break
214 done
215 fi
216 export WANT_AUTOMAKE
217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
222 fi
223
224 autotools_version_sets="yes"
225} 270}
226 271
227# Internal function to run an autotools' tool 272# Internal function to run an autotools' tool
228autotools_run_tool() { 273autotools_run_tool() {
274 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
275 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
276 fi
277
278 # We do the “latest” → version switch here because it solves
279 # possible order problems, see bug #270010 as an example.
280 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
281 local pv
282 for pv in ${_LATEST_AUTOMAKE} ; do
283 # has_version respects ROOT, but in this case, we don't want it to,
284 # thus "ROOT=/" prefix:
285 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv"
286 done
287 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
288 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
289 fi
290 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
291
229 local STDERR_TARGET="${T}/$$.out" 292 local STDERR_TARGET="${T}/$1.out"
230 local ris 293 # most of the time, there will only be one run, but if there are
294 # more, make sure we get unique log filenames
295 if [[ -e ${STDERR_TARGET} ]] ; then
296 STDERR_TARGET="${T}/$1-$$.out"
297 fi
231 298
232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 299 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
234 300
235 ebegin "Running $@" 301 ebegin "Running $@"
236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 302 "$@" >> "${STDERR_TARGET}" 2>&1
237 ris=$? 303 eend $?
238 eend ${ris}
239 304
240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then 305 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
241 echo 306 echo
242 eerror "Failed Running $1 !" 307 eerror "Failed Running $1 !"
243 eerror 308 eerror
244 eerror "Include in your bugreport the contents of:" 309 eerror "Include in your bugreport the contents of:"
245 eerror 310 eerror
246 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}" 311 eerror " ${STDERR_TARGET}"
247 echo 312 echo
248 die "Failed Running $1 !" 313 die "Failed Running $1 !"
249 fi 314 fi
250} 315}
251 316
252# Internal function to check for support 317# Internal function to check for support
253autotools_check_macro() { 318autotools_check_macro() {
254 [[ -f configure.ac || -f configure.in ]] && \ 319 [[ -f configure.ac || -f configure.in ]] || return 0
320 local macro
321 for macro ; do
255 WANT_AUTOCONF="2.5" autoconf --trace=$1 2>/dev/null 322 WANT_AUTOCONF="2.5" autoconf --trace="${macro}" 2>/dev/null
323 done
256 return 0 324 return 0
257} 325}
258 326
259# Internal function to get additional subdirs to configure 327# Internal function to get additional subdirs to configure
260autotools_get_subdirs() { 328autotools_get_subdirs() {

Legend:
Removed from v.1.61  
changed lines
  Added in v.1.99

  ViewVC Help
Powered by ViewVC 1.1.20